Subject: [netconf] [Technical Errata Reported] RFC8341 (6493)

From: RFC Errata System <[email-masked]>
Date: Wed, 24 Mar 2021 08:19:54 -0700 (PDT)

The following errata report has been submitted for RFC8341,
"Network Configuration Access Control Model".

--------------------------------------
You may review the report below and at:
https://www.rfc-editor.org/errata/eid6493

--------------------------------------
Type: Technical
Reported by: Balazs Lengyel <[email-masked]>

Section: 3.5.2

Original Text
-------------
All the same rules as an instance-identifier apply,
except that predicates for keys are optional.  If a key
predicate is missing, then the node-instance-identifier
represents all possible server instances for that key.

Corrected Text
--------------
All the same rules as an instance-identifier apply,
except that predicates for keys are optional.  If a key
predicate is missing, then the node-instance-identifier
represents all possible server instances for that key.

Specifying prefixes for the node names is OPTIONAL. If a prefix is not specified the node-instance-identifier represents all possible server instances.

Notes
-----
For the typedef node-instance-identifier (and the leaf path) it is not clear whether the value should or should not include prefixes?
 
https://tools.ietf.org/html/rfc7950#section-9.13.2 states
"All node names in an instance-identifier value MUST be qualified with
   explicit namespace prefixes"

https://tools.ietf.org/html/rfc7950#section-14 - instance-identifier rule
indicates the prefixes are optional.

Whichever is the correct answer it should be explicitly stated.
If prefixes are optional and we have 2 leaves with the same path except the namespace/prefix I assume both are referenced (effected) by the nacm rule. Correct?

Actually this is a bit misleading also in RFC7950.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party  
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC8341 (draft-ietf-netconf-rfc6536bis-09)
--------------------------------------
Title               : Network Configuration Access Control Model
Publication Date    : March 2018
Author(s)           : A. Bierman, M. Bjorklund
Category            : INTERNET STANDARD
Source              : Network Configuration
Area                : Operations and Management
Stream              : IETF
Verifying Party     : IESG

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Wed, 24 Mar 2021 16:56:08 +0100

Section 9.13.2. is pretty clear:

   An instance-identifier value is lexically represented as a string.
   All node names in an instance-identifier value MUST be qualified with
   explicit namespace prefixes, and these prefixes MUST be declared in
   the XML namespace scope in the instance-identifier's XML element.

The errata should be rejected.

/js

PS: Section 14 is a collection of syntax rules but not every aspect of
    a language needs to be expressed in the syntax rules. Yes, it is
    possible to express the first Section 9.13.2 MUST by making the
    syntax rules a bit more complex (not reusing node-identifier) but
    even as it is now, the MUST in Section 9.13.2 applies.

On Wed, Mar 24, 2021 at 08:19:54AM -0700, RFC Errata System wrote:
> _______________________________________________
> netconf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netconf

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Thu, 25 Mar 2021 10:17:34 +0000

Hi,

I agree with Juergen that section 9.13.2 of RFC 7950 applies and hence my opinion is that this errata, against RFC 8341, should be rejected.

However, I also think that RFC 7950 isn't as clear as it should be.  Given that there is an explicit ABNF construct for instance-identifier, I really think that this ABNF should explicitly require prefixes for node-identifiers, avoiding any potential ambiguity in what is allowed.

Regards,
Rob

> -----Original Message-----
> From: Juergen Schoenwaelder <[email-masked]>
> Sent: 24 March 2021 15:56
> To: RFC Errata System <[email-masked]>
> Cc: [email-masked]; [email-masked]; [email-masked]; Rob Wilton
> (rwilton) <[email-masked]>; [email-masked];
> [email-masked]; [email-masked]
> Subject: Re: [netconf] [Technical Errata Reported] RFC8341 (6493)
> 
> > Specifying prefixes for the node names is OPTIONAL. If a prefix is not
> specified the node-instance-identifier represents all possible server
> instances.
> >
> > Notes
> > -----
> > For the typedef node-instance-identifier (and the leaf path) it is not
> clear whether the value should or should not include prefixes?
> >
> > If prefixes are optional and we have 2 leaves with the same path except
> the namespace/prefix I assume both are referenced (effected) by the nacm
> rule. Correct?
> >